 /* Gauss Code for Table 3, i.e. Sargan test */
new;
closeall;


/* Different values for Pi0 */
vecpi=seqa(1,-0.1,9)|seqa(0.1,-0.02,5)|0.01|0.005|0.002|0.001|0;

/* Output file */
nomfic="sargantest.out";

output file=^nomfic reset;
"Sargan Test - second example";
output off;


affic={};
i0=1;
do until i0>rows(vecpi);
pi0=vecpi[i0];

/* True value */
beta=2;

/* Directions */
q=-1~1;

/* Sample sizes */
matn=100~500~1000~2500;

/*Number of simulations */
nsimu=1000;

/* Size of the test */
alpha=0.05;

/* Random generator */
rndseed 8769;

/* To save the results */
ressargan={};


/* Beginning of the loop across sample sizes */
rn=1;
do until rn>cols(matn);
n=matn[rn];

matdel={};
ns=1;
do until ns>nsimu;

/* DGP */
eps=rndu(n,1)-0.5;
x=(rndu(n,1)*2-1)*sqrt(3);
y=x*beta+eps;


v=rndn(n,1);



yinf=y+v.*(v.<0);
ysup=y+v.*(v.>=0);

/* Supernumerary Instrument */

tir1=rndu(n,1);
test=(tir1.>(pi0));
z=test.*v+(1-test).*rndn(n,1);




/* Decomposition zf, zh */
zf=x;
zh=z-(meanc(z.*x)/meanc(x.*x))*x;
expl=zf~zh;
sigmahat=inv(expl'*expl/n);
ztq=expl*sigmahat;

/* delta(Pi/2) */
q=0|1;
zq=ztq*q;
wq=yinf+(ysup-yinf).*(zq.>0);
deltapisd=meanc(zq.*wq);
betapisd=sigmahat*(meanc(zf.*wq)|meanc(zh.*wq));
/* Estimation of the Variance*/
epsq=wq-expl*betapisd;
zqeq=zq.*epsq;
vdelpisd=(zqeq)'*zqeq/n; /* Variance of deltaq */

/* delta(3Pi/2) */
q=0|(-1);
zq=ztq*q;
wq=yinf+(ysup-yinf).*(zq.>0);
delta3pisd=meanc(zq.*wq);
beta3pisd=sigmahat*(meanc(zf.*wq)|meanc(zh.*wq));
/* Estimation of the Variance*/
epsq=wq-expl*beta3pisd;
zqeq=zq.*epsq;
vdel3pisd=(zqeq)'*zqeq/n;

vsarg=vdelpisd|vdel3pisd;

/***** Sargan Test******/
tinfq=(deltapisd)|(delta3pisd);
qn=minindc(tinfq);/* qn minimizes Tn(q)*/
tnqn=minc(tinfq);


/*Test statistic */
xisargan=sqrt(n)*tnqn./sqrt(vsarg[qn]);



/* Decision */
rejectsargan=cdfn(xisargan).<alpha;




/* We save the result for this sample size */
matdel=matdel|(rejectsargan);


ns=ns+1;
endo;


/* We save the result for this pi0 */
ressargan=ressargan~(100*meanc(matdel));
rn=rn+1;
endo;
affic=affic|(pi0~ressargan);


i0=i0+1;
endo;

/* We display the results */
format /rd 10,4;
masque=ones(1,cols(matn)+1);
fmt= ("*.*lf "~0~3)|("&*.*lf \\\%"~0~1).*.ones(cols(matn)-1,1)|("&*.*lf \\\%"~0~1);

output on;
call printfm(affic,masque,fmt);
output off;
